;------------------------------------------------------------------------------
;  :	PDM.asm 
; :	   ATtiny2313,     
;				  (  - ).
;				        INT0  INT1
;				 .      PB7.
;				  PD4     (1    
;				 100 ),    PD5 -   (  ).
;				  (..     100  
;				  )     USART  
;				  ( ,   ..).  : 8 , 
;				2 -,  - 250 /)
;				       
;				.
;   :
;				   : 0 - 100%   1%
;				     -  300 
;				 :  5V.
; :	ATtiny2313
;  : 16
; :		2.3
;
; :		 .., ku_@mail.ru
;
;  .., 2010
;------------------------------------------------------------------------------
.include "tn2313def.inc"
.list

.def	temp 	= R16				;  
.def	lev		= R17				;   
.def	err		= R18				;   
.def	a		= R19				;      
.def	bout	= R20				;      B
.def	cntr	= R21				;     

.equ	max		= 100				; ""    0  max
.equ	maxD2	= 50				;  


rjmp	Reset
rjmp	INT_0
rjmp	INT_1
;------------------------------------------------------------------------------
;          ( 
; ).        ,  
;            
;        .
;   -   (   -   
; -,     ).
;  :
;    (err),    ,   
;   (a).       (maxD2 = 50).
;    ,  -    (  )
;        ,   - .
;             
;  .
;     lev     7   B.
;------------------------------------------------------------------------------
INT_0:	cbi		PORTB, 7			;     
		sbic	UCSRA,RXC			;    USART   ,  lev
									;  
		in		lev, UDR			;      .
		mov		bout, lev			;   7  lev   B ( 
		andi	bout, 0b01111111	;  )

		mov		a, lev				;       
		add		a, err				;       a = lev+err
		brvs	HiSig				;  a > 127,    .
									;      HiSig.   
									;      < maxD2 (!)
		cpi		a, maxD2			;     "a"   
		brge	HiSig				; 
LoSig:	mov		err, a				; ..   7-  bout   (. ), 
		rjmp	GoOn				;    err = a - 0
HiSig:	ori		bout, 0b10000000	;  1  7-  bout.  err = a - max,
		mov		err, a				; ..  a > max,    "" (err > 0),
		subi	err, max			;   maxD2 < a < max,  "" (err < 0)
GoOn:
		reti
;------------------------------------------------------------------------------
;       .    
; .         
;      100        
;------------------------------------------------------------------------------
INT_1:	out		PORTB, bout			;     
									;       lev
		inc		cntr				;   
		cpi		cntr, max			;    max.     
		brne	Switch				; ,      - 
		clr		cntr				;     -    
;		clr		err					;   
		cbi		PORTD, 4			;       
		nop							; 
		nop
		sbi		PORTD, 4
Switch:	cpi		lev, 0				
		brne	On					
		cbi		PORTD, 5			;  lev = 0 -    5  D 
		rjmp	Exit				;     
On:		sbi		PORTD, 5
Exit:	reti
;------------------------------------------------------------------------------
;      
;------------------------------------------------------------------------------
Reset:	ldi		temp, RAMEND		;   
		out		SPL, temp

VarInit:	;  
		clr 	lev
		clr		err
		clr 	bout
		clr		cntr		
PortsInit:	;   /
		ldi		temp, 0xFF			;   B -  .
		out		DDRB, temp
									
		ldi		temp, 0b00110000	; : PD4 - , PD5 -  ,
									;   -  
		out		DDRD, temp
		ldi		temp, 0b01001111	;   
		out		PORTD, temp
		sbi		PORTD, 4			;       
UARTInit:	;  USART
		ldi		temp, 3 
		out		UBRRL, temp
		clr		temp 
		out		UBRRH, temp			; UBRR = 3 -  16  - 250 /

		out		UCSRA, temp

		ldi 	temp, (1<<RXEN)
		out		UCSRB, temp			;  
 
		ldi		temp, (1<<UCSZ0)|(1<<UCSZ1)|(1<<USBS)
		out		UCSRC, temp			;   - 8   2 -
ExtIntInit:	;    
		ldi		temp, (1<<ISC01)|(1<<ISC11)|(1<<ISC10)
		out		MCUCR, temp			;  INT0 -  , INT1 -  
		ldi		temp, (1<<INT0)|(1<<INT1)
		out		GIMSK, temp			;    INT0  INT1
		sei
Start:		;  
		rjmp	Start
;------------------------------------------------------------------------------

